﻿Class MainWindow
  Private Const HowManyTouchPoints = 17
  Private Point(HowManyTouchPoints) As Point
  Private Down(HowManyTouchPoints) As Boolean
  Dim DownId(2) As Integer
  Private OldDistance As Point = New Point(0, 0)

  Private Sub Window_Loaded(sender As System.Object,
    e As System.Windows.RoutedEventArgs
    ) Handles MyBase.Loaded

    Me.Title = "TouchTest05"
    Dim bi As New BitmapImage
    bi.BeginInit()
    Try
      bi.UriSource = New Uri("c:\temp\penguins.jpg")
      bi.EndInit()
      ImageMain.Source = bi
    Catch ex As Exception
      MsgBox(ex.Message.ToString())
      Me.Close()
    End Try

    AddHandler Touch.FrameReported,
      New TouchFrameEventHandler(
      AddressOf Touch_FrameReported)
  End Sub

  Private Sub Touch_FrameReported(sender As Object,
    e As TouchFrameEventArgs)

    Dim touchPoints As TouchPointCollection =
      e.GetTouchPoints(Nothing)
    Dim distance As Point
    Dim downCount As Integer = 0
    Dim id As Integer
    Dim newWidth As Integer
    Dim newHeight As Integer

    For Each tp As TouchPoint In touchPoints
      id = tp.TouchDevice.Id
      Point(id) = tp.Position
      Select Case tp.Action
        Case Input.TouchAction.Down
          Down(id) = True
          OldDistance = GetDistance(DownId(0), DownId(1))
        Case Input.TouchAction.Up
          Down(id) = False
        Case Input.TouchAction.Move
          downCount = 0
          For i As Integer = 0 To HowManyTouchPoints - 1
            If Down(i) Then
              DownId(downCount) = i
              downCount += 1
              If downCount = 2 Then Exit For
            End If
          Next

          If downCount = 2 Then
            distance = GetDistance(DownId(0), DownId(1))

            If OldDistance.X <> 0 AndAlso
              distance.X <> OldDistance.X Then
              newWidth = ImageMain.Width +
                (distance.X - OldDistance.X)
              If newWidth > 0 Then _
                ImageMain.Width = newWidth
              OldDistance.X = distance.X
            End If

            If OldDistance.Y <> 0 AndAlso
              distance.Y <> OldDistance.Y Then
              newHeight = ImageMain.Height +
                (distance.Y - OldDistance.Y)
              If newHeight > 0 Then _
                ImageMain.Height = newHeight
              OldDistance.Y = distance.Y
            End If
          End If
      End Select
    Next
  End Sub

  Private Function GetDistance(id1 As Integer,
    id2 As Integer) As Point

    Return New Point(
      Math.Abs(Point(id1).X - Point(id2).X),
      Math.Abs(Point(id1).Y - Point(id2).Y))
  End Function
End Class
